<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSaveUrunOlusturmaUrun ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfSaveUrunOlusturmaUrun
 * @subpackage Arrays
 */
class ArrayOfSaveUrunOlusturmaUrun extends AbstractStructArrayBase
{
    /**
     * The SaveUrunOlusturmaUrun
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SaveUrunOlusturmaUrun[]
     */
    public $SaveUrunOlusturmaUrun;
    /**
     * Constructor method for ArrayOfSaveUrunOlusturmaUrun
     * @uses ArrayOfSaveUrunOlusturmaUrun::setSaveUrunOlusturmaUrun()
     * @param \StructType\SaveUrunOlusturmaUrun[] $saveUrunOlusturmaUrun
     */
    public function __construct(array $saveUrunOlusturmaUrun = array())
    {
        $this
            ->setSaveUrunOlusturmaUrun($saveUrunOlusturmaUrun);
    }
    /**
     * Get SaveUrunOlusturmaUrun value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SaveUrunOlusturmaUrun[]|null
     */
    public function getSaveUrunOlusturmaUrun()
    {
        return isset($this->SaveUrunOlusturmaUrun) ? $this->SaveUrunOlusturmaUrun : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSaveUrunOlusturmaUrun method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSaveUrunOlusturmaUrun method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSaveUrunOlusturmaUrunForArrayConstraintsFromSetSaveUrunOlusturmaUrun(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSaveUrunOlusturmaUrunSaveUrunOlusturmaUrunItem) {
            // validation for constraint: itemType
            if (!$arrayOfSaveUrunOlusturmaUrunSaveUrunOlusturmaUrunItem instanceof \StructType\SaveUrunOlusturmaUrun) {
                $invalidValues[] = is_object($arrayOfSaveUrunOlusturmaUrunSaveUrunOlusturmaUrunItem) ? get_class($arrayOfSaveUrunOlusturmaUrunSaveUrunOlusturmaUrunItem) : sprintf('%s(%s)', gettype($arrayOfSaveUrunOlusturmaUrunSaveUrunOlusturmaUrunItem), var_export($arrayOfSaveUrunOlusturmaUrunSaveUrunOlusturmaUrunItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SaveUrunOlusturmaUrun property can only contain items of type \StructType\SaveUrunOlusturmaUrun, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SaveUrunOlusturmaUrun value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SaveUrunOlusturmaUrun[] $saveUrunOlusturmaUrun
     * @return \ArrayType\ArrayOfSaveUrunOlusturmaUrun
     */
    public function setSaveUrunOlusturmaUrun(array $saveUrunOlusturmaUrun = array())
    {
        // validation for constraint: array
        if ('' !== ($saveUrunOlusturmaUrunArrayErrorMessage = self::validateSaveUrunOlusturmaUrunForArrayConstraintsFromSetSaveUrunOlusturmaUrun($saveUrunOlusturmaUrun))) {
            throw new \InvalidArgumentException($saveUrunOlusturmaUrunArrayErrorMessage, __LINE__);
        }
        if (is_null($saveUrunOlusturmaUrun) || (is_array($saveUrunOlusturmaUrun) && empty($saveUrunOlusturmaUrun))) {
            unset($this->SaveUrunOlusturmaUrun);
        } else {
            $this->SaveUrunOlusturmaUrun = $saveUrunOlusturmaUrun;
        }
        return $this;
    }
    /**
     * Add item to SaveUrunOlusturmaUrun value
     * @throws \InvalidArgumentException
     * @param \StructType\SaveUrunOlusturmaUrun $item
     * @return \ArrayType\ArrayOfSaveUrunOlusturmaUrun
     */
    public function addToSaveUrunOlusturmaUrun(\StructType\SaveUrunOlusturmaUrun $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SaveUrunOlusturmaUrun) {
            throw new \InvalidArgumentException(sprintf('The SaveUrunOlusturmaUrun property can only contain items of type \StructType\SaveUrunOlusturmaUrun, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SaveUrunOlusturmaUrun[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SaveUrunOlusturmaUrun|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SaveUrunOlusturmaUrun|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SaveUrunOlusturmaUrun|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SaveUrunOlusturmaUrun|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SaveUrunOlusturmaUrun|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SaveUrunOlusturmaUrun
     */
    public function getAttributeName()
    {
        return 'SaveUrunOlusturmaUrun';
    }
}
