<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfUrunDil ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfUrunDil
 * @subpackage Arrays
 */
class ArrayOfUrunDil extends AbstractStructArrayBase
{
    /**
     * The UrunDil
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\UrunDil[]
     */
    public $UrunDil;
    /**
     * Constructor method for ArrayOfUrunDil
     * @uses ArrayOfUrunDil::setUrunDil()
     * @param \StructType\UrunDil[] $urunDil
     */
    public function __construct(array $urunDil = array())
    {
        $this
            ->setUrunDil($urunDil);
    }
    /**
     * Get UrunDil value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\UrunDil[]|null
     */
    public function getUrunDil()
    {
        return isset($this->UrunDil) ? $this->UrunDil : null;
    }
    /**
     * This method is responsible for validating the values passed to the setUrunDil method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUrunDil method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateUrunDilForArrayConstraintsFromSetUrunDil(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfUrunDilUrunDilItem) {
            // validation for constraint: itemType
            if (!$arrayOfUrunDilUrunDilItem instanceof \StructType\UrunDil) {
                $invalidValues[] = is_object($arrayOfUrunDilUrunDilItem) ? get_class($arrayOfUrunDilUrunDilItem) : sprintf('%s(%s)', gettype($arrayOfUrunDilUrunDilItem), var_export($arrayOfUrunDilUrunDilItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The UrunDil property can only contain items of type \StructType\UrunDil, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set UrunDil value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\UrunDil[] $urunDil
     * @return \ArrayType\ArrayOfUrunDil
     */
    public function setUrunDil(array $urunDil = array())
    {
        // validation for constraint: array
        if ('' !== ($urunDilArrayErrorMessage = self::validateUrunDilForArrayConstraintsFromSetUrunDil($urunDil))) {
            throw new \InvalidArgumentException($urunDilArrayErrorMessage, __LINE__);
        }
        if (is_null($urunDil) || (is_array($urunDil) && empty($urunDil))) {
            unset($this->UrunDil);
        } else {
            $this->UrunDil = $urunDil;
        }
        return $this;
    }
    /**
     * Add item to UrunDil value
     * @throws \InvalidArgumentException
     * @param \StructType\UrunDil $item
     * @return \ArrayType\ArrayOfUrunDil
     */
    public function addToUrunDil(\StructType\UrunDil $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\UrunDil) {
            throw new \InvalidArgumentException(sprintf('The UrunDil property can only contain items of type \StructType\UrunDil, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->UrunDil[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\UrunDil|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\UrunDil|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\UrunDil|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\UrunDil|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\UrunDil|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string UrunDil
     */
    public function getAttributeName()
    {
        return 'UrunDil';
    }
}
