<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UrunResimYukleResponse StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:UrunResimYukleResponse
 * @subpackage Structs
 */
class UrunResimYukleResponse extends WebServisResponse
{
    /**
     * The Basarili
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $Basarili;
    /**
     * The Hatali
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $Hatali;
    /**
     * The Sonuclar
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfUrunResimYukleSonuclar
     */
    public $Sonuclar;
    /**
     * The UrunResimYukleResult
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\UrunResimYukleResponse
     */
    public $UrunResimYukleResult;
    /**
     * Constructor method for UrunResimYukleResponse
     * @uses UrunResimYukleResponse::setBasarili()
     * @uses UrunResimYukleResponse::setHatali()
     * @uses UrunResimYukleResponse::setSonuclar()
     * @uses UrunResimYukleResponse::setUrunResimYukleResult()
     * @param int $basarili
     * @param int $hatali
     * @param \ArrayType\ArrayOfUrunResimYukleSonuclar $sonuclar
     * @param \StructType\UrunResimYukleResponse $urunResimYukleResult
     */
    public function __construct($basarili = null, $hatali = null, \ArrayType\ArrayOfUrunResimYukleSonuclar $sonuclar = null, \StructType\UrunResimYukleResponse $urunResimYukleResult = null)
    {
        $this
            ->setBasarili($basarili)
            ->setHatali($hatali)
            ->setSonuclar($sonuclar)
            ->setUrunResimYukleResult($urunResimYukleResult);
    }
    /**
     * Get Basarili value
     * @return int|null
     */
    public function getBasarili()
    {
        return $this->Basarili;
    }
    /**
     * Set Basarili value
     * @param int $basarili
     * @return \StructType\UrunResimYukleResponse
     */
    public function setBasarili($basarili = null)
    {
        // validation for constraint: int
        if (!is_null($basarili) && !(is_int($basarili) || ctype_digit($basarili))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($basarili, true), gettype($basarili)), __LINE__);
        }
        $this->Basarili = $basarili;
        return $this;
    }
    /**
     * Get Hatali value
     * @return int|null
     */
    public function getHatali()
    {
        return $this->Hatali;
    }
    /**
     * Set Hatali value
     * @param int $hatali
     * @return \StructType\UrunResimYukleResponse
     */
    public function setHatali($hatali = null)
    {
        // validation for constraint: int
        if (!is_null($hatali) && !(is_int($hatali) || ctype_digit($hatali))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($hatali, true), gettype($hatali)), __LINE__);
        }
        $this->Hatali = $hatali;
        return $this;
    }
    /**
     * Get Sonuclar value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfUrunResimYukleSonuclar|null
     */
    public function getSonuclar()
    {
        return isset($this->Sonuclar) ? $this->Sonuclar : null;
    }
    /**
     * Set Sonuclar value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfUrunResimYukleSonuclar $sonuclar
     * @return \StructType\UrunResimYukleResponse
     */
    public function setSonuclar(\ArrayType\ArrayOfUrunResimYukleSonuclar $sonuclar = null)
    {
        if (is_null($sonuclar) || (is_array($sonuclar) && empty($sonuclar))) {
            unset($this->Sonuclar);
        } else {
            $this->Sonuclar = $sonuclar;
        }
        return $this;
    }
    /**
     * Get UrunResimYukleResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\UrunResimYukleResponse|null
     */
    public function getUrunResimYukleResult()
    {
        return isset($this->UrunResimYukleResult) ? $this->UrunResimYukleResult : null;
    }
    /**
     * Set UrunResimYukleResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\UrunResimYukleResponse $urunResimYukleResult
     * @return \StructType\UrunResimYukleResponse
     */
    public function setUrunResimYukleResult(\StructType\UrunResimYukleResponse $urunResimYukleResult = null)
    {
        if (is_null($urunResimYukleResult) || (is_array($urunResimYukleResult) && empty($urunResimYukleResult))) {
            unset($this->UrunResimYukleResult);
        } else {
            $this->UrunResimYukleResult = $urunResimYukleResult;
        }
        return $this;
    }
}
